function [m_pos] = moon(mjd)

T  = (mjd - 51544.5)/36525;
L0 = (218.31617 + 481267.88088*T - 1.3972*T); %degree
l  = (134.96292 + 477198.86753*T);            %degree
lp = (357.52543 +  35999.04944*T);            %degree
F  = ( 93.27283 + 483202.01873*T);            %degree
D  = (297.85027 + 445267.11135*T);            %degree 
obl = 23.43929111;                            %degree

long = L0 + ( 22640*sind(l) + 769*sind(2*l)...
            - 4586*sind(l - 2*D) + 2370*sind(2*D)...
            - 668*sind(lp) - 412*sind(2*F)...
            - 212*sind(2*l - 2*D) - 206*sind(l + lp - 2*D)...
            + 192*sind(l + 2*D) - 165*sind(lp - 2*D)...
            + 148*sind(l - lp) - 125*sind(D)...
            - 110*sind(l + lp) - 55*sind(2*F - 2*D))/3600; %degree

lat  = ( 18520*sind(F + long - L0 + (412*sind(2*F) + 541*sind(lp))/3600)...
        - 526*sind(F - 2*D) + 44*sind(l + F - 2*D)...
        - 31*sind(-l + F - 2*D) - 25*sind(-2*l + F)...
        - 23*sind(lp + F - 2*D) + 21*sind(-l + F)...
        + 11*sind(-lp + F - 2*D))/3600;
    
dist = ( 385000 - 20905*cosd(l) - 3699*cosd(2*D -l)...
        - 2956*cosd(2*D) - 570*cosd(2*l) + 246*cosd(2*l - 2*D)...
        - 205*cosd(lp - 2*D) - 171*cosd(l + 2*D)...
        - 152*cosd(l + lp - 2*D))*1; % km
    
long = mod(long,360);
lat  = mod( lat,360);

m_pos = [(dist*cosd(long)*cosd(lat));...
         (dist*sind(long)*cosd(lat));...
         (dist*sind(lat))]; %km
     
m_pos = rotation(m_pos,-obl,1);

% ECI to ECEF
fday = mjd - floor(mjd);
JDN  = mjd - 15019.5;
gstr = mod((279.690983 + 0.9856473354*JDN + 360*fday + 180),360);
m_pos = rotation(m_pos,gstr,3);
m_pos = m_pos*1000;

end

